#include <cstdio>
#include <cstdlib>

#include "se_kkp/parse.h"
#include "se_kkp/utils.h"

int main(int argc, char **argv) {
  if (argc != 3 && argc != 4) {
    fprintf(stderr, "usage: %s <mem> <file> [<outfile>]\n\n"
                    "Compute LZ77 parsing of <file> using <mem> MiB\n"
                    "of RAM and writes to <outfile> (if given).\n"
                    "NOTE: <file>.sa5 must be present.\n",
                    argv[0]);
    std::exit(EXIT_FAILURE);
  }

  long ram_use = ((long)atoi(argv[1])) << 20;

  // Detect the STXXL configuration file.
  utils::find_stxxl_config();

  std::string in_filename = argv[2];
  std::string out_filename = "";

  if (argc == 4)
    out_filename = argv[3];

  parse_file(in_filename, ram_use, out_filename);
}
